      *****************************************************************
      *                PASSDUMP is a COBOL Copy File                  *
      *     Data Structure or Pass Area used for calling SIMODUMP.    *
      *         Copyright (C) 1987-2019 SimoTime Technologies         *
      *                     All Rights Reserved                       *
      *****************************************************************
      *              Provided by SimoTime Technologies                *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
      * Values for SIMODUMP-REQUEST                                   *
      * DUMP   Dump the Buffer in Hexadecimal format                  *
      * NOTE   Display or Write the text to the screen or log file    *
      *                                                               *
      * Values for SIMODUMP-SYSOUT                                    *
      * OPR1   Display dump information on operator console           *
      * OPR2   Display to operator console and write to log file      *
      * OUT1   Display dump information to SYSOUT device              *
      * OUT2   Display to SYSOUT device and write to log file         *
      * LOG1   Write dump information to the log file (SYSLOG)        *
      * NONE   Do not output to screen or file, put dump info in      *
      *        pass area table and return to caller.                  *
      *                                                               *
      * Values for SIMODUMP-COPYRIGHT                                 *
      * HIDE   Do not display the copyright information. Any other    *
      *        entry will display the copyright information.          *
      *****************************************************************
       01  SIMODUMP-PASS-AREA.
      *    Initial information is provided by the calling program,
      *    The SIMODUMP-REQUEST field will be modified to "DUMP" if it
      *    does not contain a valid entry.
      *    The SIMODUMP-RESULT field may also be modified by the
      *    SimoDUMP routine.
           05  SIMODUMP-REQUEST        PIC X(4).
           05  SIMODUMP-RESULT         PIC 9999.
      *    The following are not modified by the SimoDUMP routine...
           05  SIMODUMP-DUMP-ID        PIC X(8).
           05  SIMODUMP-OUTPUT         PIC X(4).
           05  SIMODUMP-COPYRIGHT      PIC X(4).
      *    The following are modified by the SimoDUMP routine...
           05  SIMODUMP-IDX            PIC 99.
           05  SIMODUMP-LINES          PIC X(80)   OCCURS 8 TIMES.
      *    The following are not modified by the SimoDUMP routine...
           05  SIMODUMP-LENGTH         PIC 9(4).
       01  SIMODUMP-BUFFER             PIC X(128).
      *
      ***  PASSDUMP - End-of-Copy File - - - - - - - - - - - PASSDUMP *
      *****************************************************************
      *
